<template>
    <div
        v-if="shop"
        class="page-container"
    >
        <div class="video-button-container">
            <VideoButton :source="'https://carti.crisp.help/en/article/push-campaigns-164enn3/reader'" />
        </div>
        <div class="row">
            <PushCard
                v-for="(card, index) in campaignsCards"
                :key="index"
                class="col-lg-4"
                :cart-data="card"
                :loader="loading"
            />
        </div>
        <PushCampaignsContent
            :draft-page="draftsPage"
            :drafts="drafts"
            :campaigns="campaigns"
            :schedule-page="schedulesPage"
            :history-page="historiesPage"
            :histories="histories"
            @getDrafts="getDrafts"
            @getCampaigns="getCampaigns"
            @getHistories="getHistories"
        />
    </div>
</template>

<script>
import PushCard from "@/components/push/abandoned-carts/PushCard";
import PushCampaignsContent from "@/components/push/campaigns/PushCampaignsContent";
import currencies from "@/data/currencies.json";
import pushCampaigns from "@/mixins/push/campaigns.service";
import shop from "@/mixins/shop.service";
import VideoButton from "@/components/header/VideoButton";

export default {
    name: "Index",
    components: {PushCampaignsContent, PushCard, VideoButton},
    mixins: [pushCampaigns, shop],
    data() {
        return {
            campaignsCards: [
                {
                    title: 'Revenue Recovered',
                    icon: 'fa fa-window-maximize',
                    salesCount: '0',
                    salesTitle: 'Sales'
                },
                {
                    title: 'Subscribers',
                    icon: 'fa fa-users',
                    salesCount: '0',
                    salesTitle: 'Quantity'
                },
                {
                    title: 'Orders Recovered',
                    icon: 'fa fa-cube',
                    salesCount: '0',
                    salesTitle: 'Quantity'
                }
            ],
            shop: null,
            carts: null,
            loading: true,
            helpModalId: 'HelpModalEmailCampaigns',
            drafts: null,
            currencies: currencies,
            campaigns: null,
            histories: null,
            draftsPage: {
                number: 1
            },
            schedulesPage: {
                number: 1
            },
            historiesPage: {
                number: 1
            },
        }
    },
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        }
    },
    created() {
        this.loadShop()
    },
    mounted() {
        this.getCampaignsCarts()
        this.getDrafts()
        this.getCampaigns()
        this.getHistories()
    },
    methods: {
        async loadShop() {
            this.shop = await this.getShop()
        },
        async getCampaignsCarts() {
            this.carts = null
            const response = await this.getCarts();
            this.carts = response.data;
            this.campaignsCards = [
                {
                    title: 'Revenue Recovered',
                    icon: 'fa fa-window-maximize',
                    salesCount: this.getCurrencySign.symbol_native + this.carts.total_revenue,
                    salesTitle: 'Sales'
                },
                {
                    title: 'Subscribers',
                    icon: 'fa fa-users',
                    salesCount: this.carts.total_subscribers,
                    salesTitle: 'Quantity'
                },
                {
                    title: 'Orders Recovered',
                    icon: 'fa fa-cube',
                    salesCount: this.carts.total_orders,
                    salesTitle: 'Quantity'
                }
            ]
            this.loading = false
            // }).catch(error => {
            //     if (error.status === 429) {
            //         this.$notify({
            //             type: 'error',
            //             title: 'Too many requests'
            //         });
            //     } else {
            //         this.$notify({
            //             type: 'error',
            //             title: 'Server error'
            //         });
            //     }
            // });
        },
        getDrafts(pageNum = 1) {
            this.draftsPage.number = pageNum
            this.getAllDrafts(pageNum).then(response => (this.drafts = response.data)).catch(error => {
                console.log(error)
            });

        },
        getCampaigns(pageNum = 1) {
            this.schedulesPage = pageNum
            this.getAllCampaigns(pageNum).then(response => (this.campaigns = response.data)).catch(error => {
                console.log(error)
            });
        },
        getHistories(pageNum = 1) {
            this.historiesPage = pageNum
            this.getAllHistories(pageNum).then(response => (this.histories = response.data)).catch(error => {
                console.log(error)
            });
        }
    }
}
</script>

<style lang="scss">
.push-campaigns .crisp-client .cc-kv6t[data-full-view="false"] .cc-1xry .cc-unoo, .crisp-client .cc-kv6t[data-full-view="false"] .cc-1xry .cc-ge4v {
    margin-bottom: 10px !important;
}
</style>
